#
# spec file for package subversion (Version 0.27.0)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  apache2-devel-packages blt db-devel docbook-xsl-stylesheets docbook2x docbook_4 freetype2 libapr0 libxml libxml-devel libxml2 libxslt neon neon-devel openjade opensp openssl-devel perl-XML-DOM perl-XML-Parser python python-devel python-imaging python-tk swig tcl tcl-devel tidy tix tk x-devel-packages
# usedforbuild    aaa_base acl attr bash bind9-utils bison coreutils cpio cpp cvs cyrus-sasl2 db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs apache2 apache2-devel apache2-prefork autoconf automake binutils blt bzip2 cracklib db-devel docbook-xsl-stylesheets docbook2x docbook_4 expat freetype2 gcc gdbm gettext libapr0 libtool libxml libxml-devel libxml2 libxslt neon neon-devel openjade opensp openssl openssl-devel perl perl-XML-DOM perl-XML-Parser python python-devel python-imaging python-tk rpm swig tcl tcl-devel tidy tix tk

Name:         subversion
Version:      0.27.0
Release:      29
#
%define	apxs	/usr/sbin/apxs2
%define	apache_libexecdir	%(%{apxs} -q LIBEXECDIR)
%define	apache_sysconfdir	%(%{apxs} -q SYSCONFDIR)
#
%define site_python	%(python -c 'import site; print site.sitedirs[0];')
#
%define	docbook_xsl_version	1.60.1 
#
%define viewcvs_dir /srv/viewcvs
%define mydocdir %_defaultdocdir/%name
#
PreReq:       %insserv_prereq %fillup_prereq
#
Summary:      A Concurrent Versioning system similar to but better than CVS.
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
License:      Other License(s), see package
Group:        Development/Tools/Version Control
URL:          http://subversion.tigris.org
Source0:      subversion-%{version}.tar.bz2
Source1:      subversion.conf
Source2:      subversion.README.SuSE
Source3:      http://prdownloads.sourceforge.net/docbook/docbook-xsl-%{docbook_xsl_version}.tar.gz
# w3m -dump_head http://svnbook.red-bean.com/book.pdf
#Source4:      http://svnbook.red-bean.com/subversion.book.pdf
Source5:      subversion-excludes.txt
Source6:      subversion.doc.conf
Source7:      subversion.viewcvs-cvs.tar.bz2
Source8:      subversion.viewcvs.conf
Source9:      subversion.rcsvnserve
Source10:     subversion.sysconfig.svnserve
#
Patch1:       subversion-editor.patch
Patch2:       subversion-keywords_on_add.patch
Patch6:       subversion-SVNLOOK.patch
# build fixes
Patch3:       subversion-sed_abusers.patch
Patch4:       subversion-python_bytecode-path-pr1131.patch 
#
Patch5:       subversion.viewcvs.patch

%description
Subversion does the same thing CVS does (Concurrent Versioning System) but has
major enhancements compared to CVS.

http://subversion.tigris.org

%package doc
Group:        Development/Tools/Version Control
Summary:      subversion-doc

%description doc
subversion-doc

%package devel
Group:        Development/Libraries/C and C++
Summary:      Development package for Subversion developers.
Requires:     subversion = %{version}-%{release}

%description devel
The subversion-devel package includes the static libraries and include files
for developers interacting with the subversion package.

%package cvs2svn
Requires:     swig
Group:        Development/Tools/Version Control
Summary:      Converts CVS repositories to Subversion repositories.
%define pyver %(python -c 'import sys; print sys.version[:3]')
Requires:     python >= %pyver, python < %{pyver}.99

%description cvs2svn
Converts CVS repositories to Subversion repositories.

See /usr/share/doc/packages/subversion*/tools/cvs2svn directory for more information.

%package tools
Group:        Development/Tools/Version Control
Summary:      Tools for Subversion

%description tools
Tools for Subversion

SuSE series: suse

%package server
Group:        Development/Tools/Version Control
Summary:      Apache server module for Subversion server.
Requires:     subversion = %{version}-%{release}
Requires:     apache2

%description server
The subversion-server package adds the Subversion server Apache module to
the Apache directories and configuration.

http://subversion.tigris.org

%package viewcvs
# for the python bindings
Requires:     subversion-cvs2svn
Group:        Development/Tools/Version Control
Summary:      subversion-viewcvs

%description viewcvs
subversion-viewcvs

%prep
%setup -q -a 3 -a 7
%patch1
%patch2
%patch6
#fixes
%patch3
%patch4
mv -v docbook-xsl-%{docbook_xsl_version} doc/book/tools/xsl
#cp -av %{S:4} .
cd viewcvs-cvs
%patch5
cd ..

%build
# ### these possibly need further discussion
# swig_pydir = @libdir@/svn-python/libsvn
# swig_pydir_extra = @libdir@/svn-python/svn
mv Makefile.in{,.}
sed "
s@^swig_pydir = .*@swig_pydir = %{site_python}/libsvn@
s@^swig_pydir_extra = .*@swig_pydir_extra = %{site_python}/svn@
" < Makefile.in. > Makefile.in
diff -u Makefile.in. Makefile.in || true
sh -x autogen.sh
export CFLAGS="$(%{apxs} -q CFLAGS) -Wall -g"
./configure \
	--prefix=/usr \
	--infodir=%{_infodir} \
	--libdir=%{_libdir} \
	--mandir=%{_mandir} \
	--with-editor="vim -c 'set tw=72 et' " \
	--with-neon=/usr \
	--with-apr=/usr \
	--with-apr-util=/usr \
	--with-apxs=%{apxs} \
	--with-zlib \
	--disable-mod-activation
make
# Build cvs2svn python bindings
make swig-py
#
# yuck..
export PATH=$PWD/subversion/svnversion:$PATH
make doc-all-html

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT external-install local-install
#
mkdir -p $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d
cp -av %{S:1} $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d/subversion.conf
cp -av %{S:6} $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d/subversion.doc.conf
cp -av %{S:8} $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d/subversion.viewcvs.conf
# subversion-doc
mkdir -p %buildroot/%mydocdir/
mkdir html
cp -av doc/book/book/*.html			html/
cp -av doc/book/book/images			html/
cp -av doc/programmer/design/svn-design.html	html/
cp -av doc/book/misc-docs/misc-docs.html	html/
find html -name .svn -print0 | xargs -0 rm -rf
find html -name "*.ppt" -print0 | xargs -0 rm -rf
#
cp -av %{S:2} README.SuSE
cp -av README.SuSE BUGS CHANGES COPYING subversion/LICENSE html %buildroot/%mydocdir/
#
find %buildroot/%mydocdir -type d | sed '
s:%buildroot:%dir :
/\/html\//{
w files.subversion.doc.d
d
}
w files.subversion.d
d
'
find %buildroot/%mydocdir -type f | sed '
s:%buildroot:%doc :
/\/html\/\|\.pdf$/{
w files.subversion.doc.f
d
}
w files.subversion.f
d
'
cat files.subversion.{d,f} > files.subversion
cat files.subversion.doc.{d,f} > files.subversion.doc
#
# cvs2svn
make install-swig-py DESTDIR=$RPM_BUILD_ROOT
sed -e 's;#!/usr/bin/env python;#!/usr/bin/env python;' < \
tools/cvs2svn/cvs2svn.py > \
$RPM_BUILD_ROOT/usr/bin/cvs2svn
chmod a+x $RPM_BUILD_ROOT/usr/bin/cvs2svn
mkdir -p $RPM_BUILD_ROOT%{site_python}/rcsparse/
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1/
cp -av tools/cvs2svn/rcsparse/*.py $RPM_BUILD_ROOT%{site_python}/rcsparse/
cp -av tools/cvs2svn/cvs2svn.1 $RPM_BUILD_ROOT%{_mandir}/man1/
#
# tools
mkdir -p   $RPM_BUILD_ROOT/usr/share/subversion/
cp -a tools $RPM_BUILD_ROOT/usr/share/subversion/
rm -rf $RPM_BUILD_ROOT/usr/share/subversion/tools/cvs2svn
find $RPM_BUILD_ROOT html -name .svn -type d | xargs rm -rf
find $RPM_BUILD_ROOT html -name CVS -type d | xargs rm -rf
find $RPM_BUILD_ROOT html -name tests -type d | xargs rm -rf
# viewcvs
pushd .
cd viewcvs-cvs/
( echo %{viewcvs_dir} ; echo $RPM_BUILD_ROOT ) | ./viewcvs-install 
sed '
s@^default_root.*@default_root = your_unnamed_project@
s@^cvsgraph_conf.*@cvsgraph_conf = %{viewcvs_dir}/cvsgraph.conf@
s@^hr_funout.*@hr_funout = 1@
s@^show_changed_paths.*@show_changed_paths = 0@
/^cvs_roots/,/^$/s/^/###/
/^#svn_roots/,/^$/c\
svn_roots:\
	your_unnamed_project : /srv/svn/repos/<your_unnamed_project> , \
	another_project : /srv/svn/repos/<another_project> \
#
' < viewcvs.conf.dist > $RPM_BUILD_ROOT%{viewcvs_dir}/viewcvs.conf
diff -up viewcvs.conf.dist $RPM_BUILD_ROOT%{viewcvs_dir}/viewcvs.conf || true
popd
find $RPM_BUILD_ROOT%{viewcvs_dir} -type d | \
sed "s@$RPM_BUILD_ROOT@%dir @" > files.subversion.viewcvs
find $RPM_BUILD_ROOT%{viewcvs_dir} -type f | \
sed "s@$RPM_BUILD_ROOT@@;/\/templates\/\|\.conf$/s@^@%config (noreplace) @" >> files.subversion.viewcvs
#
#
#
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
cp -a %_sourcedir/subversion.rcsvnserve $RPM_BUILD_ROOT/etc/init.d/svnserve
ln -sv /etc/init.d/svnserve $RPM_BUILD_ROOT/usr/sbin/rcsvnserve
cp -a %_sourcedir/subversion.sysconfig.svnserve $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.svnserve
#

%post
%{fillup_and_insserv svnserve}
%{run_ldconfig}

%postun
%{insserv_cleanup}

%files -f files.subversion
%defattr(-,root,root)
#
%attr(754,root,root) /etc/init.d/svnserve
/usr/sbin/rcsvnserve
/var/adm/fillup-templates/sysconfig.svnserve
#
/usr/bin/svn
/usr/bin/svnadmin
/usr/bin/svndumpfilter
/usr/bin/svnlook
/usr/bin/svnserve
/usr/bin/svnversion
%{_libdir}/libsvn*so*
%doc %{_mandir}/man1/svn*

%files doc -f files.subversion.doc
%defattr(-,root,root)
%dir %{apache_sysconfdir}/conf.d
%config (noreplace) %{apache_sysconfdir}/conf.d/subversion.doc.conf

%files devel
%defattr(-,root,root)
%dir /usr/include/subversion-1
%{_libdir}/libsvn*.a
%{_libdir}/libsvn*.la
/usr/include/subversion-1/*

%files cvs2svn
%defattr(-,root,root)
/usr/bin/cvs2svn
%dir %{site_python}
%dir %{site_python}/libsvn
%dir %{site_python}/rcsparse
%dir %{site_python}/svn
%{site_python}/libsvn/*
%{site_python}/svn/*
%{site_python}/rcsparse/*
%{_mandir}/man1/cvs2svn*

%files tools
%defattr(-,root,root)
%dir /usr/share/subversion
/usr/share/subversion/tools

%files server
%defattr(-,root,root)
%dir %{apache_sysconfdir}/conf.d
%config (noreplace) %{apache_sysconfdir}/conf.d/subversion.conf
%dir %{apache_libexecdir}
%{apache_libexecdir}/mod_dav_svn.*
%{apache_libexecdir}/mod_authz_svn.*

%files viewcvs -f files.subversion.viewcvs
%defattr(-,root,root)
%dir %{apache_sysconfdir}/conf.d
%config (noreplace) %{apache_sysconfdir}/conf.d/subversion.viewcvs.conf

%changelog -n subversion
* Mon Sep 08 2003 - poeml@suse.de
- subversion-viewcvs: explicitely allow access to the
  /srv/viewcvs/www/cgi directory, because we can not take it for
  granted that apache2 allows it by default [#29729]
* Fri Aug 29 2003 - poeml@suse.de
- README.SuSE: add documentation on file permissions; fold in
  feedback from Heinrich Stamerjohanns
* Fri Aug 29 2003 - mcihar@suse.cz
- subversion-cvs2svn requires python
* Wed Aug 27 2003 - olh@suse.de
- do not install the book.pdf
* Mon Aug 18 2003 - olh@suse.de
- update to 0.27.0, revision 6740
  update viewcvs to todays cvs status
* Sun Aug 10 2003 - olh@suse.de
- update to pre 0.27, revision 6695
* Sun Aug 10 2003 - olh@suse.de
- add rcsvnserve
  update hook template, svnlook is in /usr/bin
  update viewcvs to todays cvs status
* Wed Jul 30 2003 - poeml@suse.de
- get CFLAGS from apxs, so they match the ones that apr and apache2
  were built with
- "make external-install local-install" targets instead of make
  install, to work avoid hard coded pulling of the revision number
  from the svn working copy in the revision-install target
* Fri Jul 25 2003 - olh@suse.de
- update to 0.26.0, revision 6576
* Sun Jul 20 2003 - olh@suse.de
- split packages subversion-doc and subversion-viewcvs
  use SVN_DOC instead of SVN_DOCU
  use SVN_VIEWCVS to enable the scriptalias
* Sat Jul 12 2003 - olh@suse.de
- update to 0.25.0, revision 6456
  use SVN_DOCU to provide html documentation via apache2
* Sat Jul 05 2003 - olh@suse.de
- add subversion-python_bytecode-path-pr1131.patch
  do not compile in RPM_BUILD_ROOT, use builddir instead
* Tue Jun 17 2003 - olh@suse.de
- update to 0.24.1 final, revision 6254
  update svnbook.red-bean.com/book.pdf
* Tue Jun 17 2003 - kukuk@suse.de
- Add missing directory to filelist
* Mon May 19 2003 - olh@suse.de
- update to 0.23.0 final, revision 5981
  add subversion-infopages.patch
* Sat May 10 2003 - olh@suse.de
- update to 0.22.1 final, revision 5877
  use apache-2.0.45 apr
* Fri May 02 2003 - olh@suse.de
- update to 0.22.0 , revision 5780
  build with newer apr
* Fri Apr 11 2003 - ro@suse.de
- fix deprecated head/tail calling syntax (-1)
* Wed Mar 19 2003 - olh@suse.de
- update to 0.19.1 , revision 5394
* Sun Mar 16 2003 - olh@suse.de
- update to 0.19.1 , revision 5349
  update book.pdf
* Tue Feb 18 2003 - poeml@suse.de
- python might live below /usr/lib64
* Thu Feb 13 2003 - olh@suse.de
- update to 0.17.1 , revision 4877
  finally a working cvs2svn version, use the cvs2svn-mmacek branch
* Mon Feb 10 2003 - poeml@suse.de
- remove hints about SuSEconfig, it's not needed. Add README.SuSE
  about server configuration
- drop /etc/apache2/modules/subversion, it is no longer needed
- MPM specific links to mod_dav_svn.so are no longer needed
- server requires apache2, and a Require on apr is no longer valid
* Mon Feb 10 2003 - olh@suse.de
- split packages cvs2svn and tools
* Thu Feb 06 2003 - olh@suse.de
- add hint about SuSEconfig run in subversion.conf example
* Sun Feb 02 2003 - olh@suse.de
- add subversion-0.17.1-editor.diff
  subversion-0.17.1-keywords_on_add.diff
* Tue Jan 28 2003 - olh@suse.de
- add subversion book.pdf from the website
  add svnserve and svnversion
  remove outdated info docu
  build and add html documentation
  new apache2 config file format, extend example in subversion.conf
* Wed Jan 22 2003 - olh@suse.de
- update to 0.17.1 , revision 4508
* Tue Jan 21 2003 - olh@suse.de
- update to 0.17.0 , revision 4474
* Thu Dec 05 2002 - poeml@suse.de
- update to 0.16.0 , revision 3987
- use macro <apache2-devel-packages> in #neededforbuild
- get rid of hardcoded MPM names
* Wed Dec 04 2002 - olh@suse.de
- update to 0.15.0 , revision 3985
* Mon Nov 11 2002 - ro@suse.de
- changed neededforbuild <xshared> to <x-devel-packages>
- changed neededforbuild <xdevel> to <>
* Sun Oct 13 2002 - olh@suse.de
- update to 0.14.3 , revision 3360
  add subversion configfiles for apache2
* Sat Oct 12 2002 - olh@suse.de
- update to 0.14.3 , revision 3353
  add more dir path to file list, add more docu
  apxs is in /usr/sbin
* Thu Sep 19 2002 - olh@suse.de
- update to 0.14.3 , revision 3188
  use python-imaging instead of python-tkinter
* Sat Aug 31 2002 - poeml@suse.de
- update to last release 0.14.2 (svn update was broken when
  repositories contained renames)
* Tue Aug 27 2002 - poeml@suse.de
- use apxs2, building a common mod_dav_svn.so for all three MPMs
- don't let apxs add an entry for mod_dav_svn.so into httpd.conf
* Sun Aug 11 2002 - olh@suse.de
- update to 0.14.1, rev 2935, build html docs
* Thu Aug 01 2002 - olh@suse.de
- update to 2840, add svnadmin and svnlock
* Tue Jul 30 2002 - olh@suse.de
- remove apr, use apache2 instead, update to 2787
* Fri Jul 26 2002 - olh@suse.de
- initial SuSE release with version 0.14.0.2720
  built with apr_20020725163531 and apr-util-20020725
